/* SPecCC: Specification Consistency Checking
 *
 * Copyright (c) 2014, Rongjie Yan, 
 * All rights reserved.
    
 * This file is part of SpecCC.

 * SpecCC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 *  SpecCC is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with SpecCC.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * SpecC.java
 *
 * Created on Sep 3, 2013, 6:38:43 PM
 */
package specc.gui;
import javax.swing.JFileChooser;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.text.*;
import javax.script.*;
import org.python.util.PythonInterpreter;  
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.JList;
import javax.swing.SwingUtilities;
//import javax.swing.ImageIcon;
//import g4ltl.SolverUtility;
import g4ltl.utility.CompositionalProblemDescription;
import g4ltl.utility.CompressibilityCheck;
import g4ltl.utility.ResultLTLSynthesis;
import g4ltl.utility.SynthesisEngine;
import g4ltl.utility.ProblemDescription;
import g4ltl.utility.PtolemyTemplate;
/**
 *
 * @author yrj
 */
public class SpecC extends javax.swing.JFrame {
    //variable declaration
    File selectedFile = null;
    boolean hasLoadFile = false;
    protected String lastDir = null;
    String outputFile = "output.txt";
    
    ArrayList<String> inputSignals = new ArrayList<String>();
    ArrayList<String> outputSignals = new ArrayList<String>();
    int inputAdjust = -1;
    int outputAdjust= -1;
    int allowedBound = 5;
    HashMap<String, String> spec = new HashMap<String,String>();
    String LTL = "LTL";
    String INPUT = "INPUT";
    String OUTPUT = "OUTPUT";
    
    /** Creates new form SpecC */
    public SpecC() {
        
        try {
            // Set cross-platform Java L&F (also called "Metal")
            UIManager.setLookAndFeel(
            UIManager.getSystemLookAndFeelClassName());
        } 
        catch (UnsupportedLookAndFeelException e) {
           // handle exception
        }
        catch (ClassNotFoundException e) {
           // handle exception
        }
        catch (InstantiationException e) {
           // handle exception
        }
        catch (IllegalAccessException e) {
           // handle exception
        }
        initComponents();
        
        DefaultListModel dlminput = new DefaultListModel();
        //jTextFieldErrorBound.setVisible(false);
        //jLableError.setVisible(false);
        jListInput.setModel(dlminput);
        jListOutput.setModel(dlminput);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroupFrontEnd = new javax.swing.ButtonGroup();
        buttonGroupOutput = new javax.swing.ButtonGroup();
        buttonGroupFeature = new javax.swing.ButtonGroup();
        buttonGroupAbstraction = new javax.swing.ButtonGroup();
        jMenu1 = new javax.swing.JMenu();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaSpec = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextAreaLTL = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jListInput = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jListOutput = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jRadioButtonPsuedocode = new javax.swing.JRadioButton();
        jRadioButtonSAL = new javax.swing.JRadioButton();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextAreaResult = new javax.swing.JTextArea();
        jPanel7 = new javax.swing.JPanel();
        jButtonChecking = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldUnroll = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        jButtonConvert = new javax.swing.JButton();
        jRadioButtonReduction = new javax.swing.JRadioButton();
        jRadioButtonAbstraction = new javax.swing.JRadioButton();
        jLabelAbstraction = new javax.swing.JLabel();
        jButtonLoadFile = new javax.swing.JButton();
        jLabelError = new javax.swing.JLabel();
        jTextFieldErrorBound = new javax.swing.JTextField();

        jMenu1.setText("jMenu1");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Specification formalization and consistency checking");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setIconImages(null);
        setName(""); // NOI18N
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Specification"));
        jPanel1.setRequestFocusEnabled(false);

        jTextAreaSpec.setColumns(20);
        jTextAreaSpec.setLineWrap(true);
        jTextAreaSpec.setRows(5);
        jScrollPane1.setViewportView(jTextAreaSpec);

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 648, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(9, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 105, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("LTL formulas"));
        jPanel2.setForeground(new java.awt.Color(255, 255, 255));

        jTextAreaLTL.setColumns(20);
        jTextAreaLTL.setRows(5);
        jScrollPane2.setViewportView(jTextAreaLTL);

        jListInput.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListInput.setVisibleRowCount(4);
        jListInput.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListInputMouseClicked(evt);
            }
        });
        jScrollPane3.setViewportView(jListInput);

        jLabel1.setText("Inputs");

        jListOutput.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListOutput.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListOutputMouseClicked(evt);
            }
        });
        jScrollPane4.setViewportView(jListOutput);

        jLabel2.setText("Outputs");

        jButton4.setText("->");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jButton5.setText("<-");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 353, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 93, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jButton4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 52, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 52, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel2)
                    .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 102, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jLabel1)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(0, 0, Short.MAX_VALUE)
                        .add(jButton4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton5)
                        .add(17, 17, 17))
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(2, 2, 2)
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.CENTER)
                            .add(jScrollPane3)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 112, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(12, 12, 12))))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .add(jLabel2)
                .add(2, 2, 2)
                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                .add(17, 17, 17))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Output format"));

        buttonGroupOutput.add(jRadioButtonPsuedocode);
        jRadioButtonPsuedocode.setSelected(true);
        jRadioButtonPsuedocode.setText("Psuedocode");
        jRadioButtonPsuedocode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonPsuedocodeActionPerformed(evt);
            }
        });

        buttonGroupOutput.add(jRadioButtonSAL);
        jRadioButtonSAL.setText("SAL format");

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .add(jRadioButtonPsuedocode)
                .add(58, 58, 58)
                .add(jRadioButtonSAL)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jRadioButtonPsuedocode)
                    .add(jRadioButtonSAL))
                .addContainerGap(11, Short.MAX_VALUE))
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Results"));

        jTextAreaResult.setColumns(20);
        jTextAreaResult.setRows(5);
        jScrollPane5.setViewportView(jTextAreaResult);

        org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane5)
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 128, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Actions"));

        jButtonChecking.setFont(new java.awt.Font("Times New Roman", 1, 12)); // NOI18N
        jButtonChecking.setText("Checking");
        jButtonChecking.setMaximumSize(new java.awt.Dimension(93, 28));
        jButtonChecking.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCheckingActionPerformed(evt);
            }
        });

        jLabel3.setText("Unroll steps:");

        jTextFieldUnroll.setText("3");
        jTextFieldUnroll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldUnrollActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel7Layout = new org.jdesktop.layout.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7Layout.createSequentialGroup()
                .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldUnroll)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jButtonChecking, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(25, 25, 25))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7Layout.createSequentialGroup()
                .add(2, 2, 2)
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.CENTER)
                    .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextFieldUnroll)
                    .add(jButtonChecking, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
        );

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("Next Operator Abstraction")));

        jButtonConvert.setFont(new java.awt.Font("Times New Roman", 1, 12)); // NOI18N
        jButtonConvert.setText("Convert");
        jButtonConvert.setMaximumSize(new java.awt.Dimension(93, 29));
        jButtonConvert.setMinimumSize(new java.awt.Dimension(93, 29));
        jButtonConvert.setPreferredSize(new java.awt.Dimension(93, 29));
        jButtonConvert.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonConvertActionPerformed(evt);
            }
        });

        buttonGroupAbstraction.add(jRadioButtonReduction);
        jRadioButtonReduction.setSelected(true);
        jRadioButtonReduction.setText("Next Operator Reduction");
        jRadioButtonReduction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonReductionActionPerformed(evt);
            }
        });

        buttonGroupAbstraction.add(jRadioButtonAbstraction);
        jRadioButtonAbstraction.setText("Next Operator Abstraction");
        jRadioButtonAbstraction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonAbstractionActionPerformed(evt);
            }
        });

        jLabelAbstraction.setText("   ");

        jButtonLoadFile.setFont(new java.awt.Font("Times New Roman", 1, 12)); // NOI18N
        jButtonLoadFile.setText("Load File");
        jButtonLoadFile.setIgnoreRepaint(true);
        jButtonLoadFile.setMaximumSize(new java.awt.Dimension(93, 29));
        jButtonLoadFile.setMinimumSize(new java.awt.Dimension(93, 29));
        jButtonLoadFile.setPreferredSize(new java.awt.Dimension(93, 29));
        jButtonLoadFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLoadFileActionPerformed(evt);
            }
        });

        jLabelError.setText("Allowed error:");
        jLabelError.setName(""); // NOI18N

        jTextFieldErrorBound.setText("4");
        jTextFieldErrorBound.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldErrorBoundActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel9Layout = new org.jdesktop.layout.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .add(jRadioButtonReduction)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabelAbstraction, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 444, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel9Layout.createSequentialGroup()
                        .add(jRadioButtonAbstraction, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 198, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabelError)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jTextFieldErrorBound, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 31, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButtonLoadFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButtonConvert, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(236, 236, 236))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jRadioButtonReduction)
                    .add(jRadioButtonAbstraction)
                    .add(jButtonConvert, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButtonLoadFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabelError)
                    .add(jTextFieldErrorBound, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jLabelAbstraction))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 675, Short.MAX_VALUE)
                    .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(jPanel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 154, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jPanel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
private void jButtonLoadFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadFileActionPerformed
// TODO add your handling code here:
    String wd = (lastDir != null) ? lastDir : System.getProperty("user.dir");
    
    JFileChooser fileChooser = new JFileChooser(wd);
    
    int result = fileChooser.showDialog(null, "Selecte the specification");
    if (result == JFileChooser.APPROVE_OPTION) {
        selectedFile = fileChooser.getSelectedFile();
        String tempName = selectedFile.getAbsolutePath();
        tempName = tempName.substring(0,tempName.length()-4);
        outputFile = tempName + "_ltl.txt";
        
        
        try
        {
              lastDir = selectedFile.getParent();
              FileReader reader = new FileReader( selectedFile );
              BufferedReader br = new BufferedReader(reader);
              jTextAreaSpec.read( br, null );
              br.close();
              jTextAreaSpec.requestFocus(); 
              hasLoadFile = true;
        }
        catch(Exception e2) { System.out.println(e2); }
        
    }
}//GEN-LAST:event_jButtonLoadFileActionPerformed

protected String replacingNextOperators(String formula, ArrayList<NextPosition> nextArray, int nextgcd){
    String newFormula = "";
    int initpos =0;
    for (int i=0; i< nextArray.size(); i++){
            newFormula = newFormula + formula.substring(initpos,nextArray.get(i).pos);
            if (nextArray.get(i).length/nextgcd < 10)
                for (int j =0; j < nextArray.get(i).length/nextgcd; j++){
                    newFormula = newFormula + "X";
                }
            else
                newFormula = newFormula + "<>";
            initpos = nextArray.get(i).pos+ nextArray.get(i).length;
    }
    newFormula = newFormula + formula.substring(initpos);
    return newFormula;
        
}
protected ArrayList<NextPosition> sortingLength(HashMap<Integer, ArrayList<NextPosition>> transformedNext, HashMap<Integer, Boolean> hasNext){
    ArrayList<NextPosition> globalNextOperator = new ArrayList<NextPosition>();
    for (int i=0; i< hasNext.size(); i++){
        if (hasNext.get(i)){
            ArrayList<NextPosition> tempNextArray = transformedNext.get(i);
            for (int j = 0; j < tempNextArray.size(); j ++){
                if (globalNextOperator.size() == 0){
                    globalNextOperator.add(tempNextArray.get(j));
                }
                else{
                    int k ;
                    for ( k = 0; k < globalNextOperator.size(); k ++){
                        NextPosition tempNextPostion = globalNextOperator.get(k);
                        if (tempNextPostion.getLength()==tempNextArray.get(j).getLength())
                            break;
                    }
                    if (k == globalNextOperator.size())
                        globalNextOperator.add(tempNextArray.get(j));
                }
            }
        }
    }
    for(int i = 0; i < globalNextOperator.size()-1 ; i++)
        for(int j = 1; j < globalNextOperator.size()-i ; j++){
            NextPosition tempNext = new NextPosition();
            if((globalNextOperator.get(j-1)).getLength() >(globalNextOperator.get(j)).getLength()) {   
                tempNext=globalNextOperator.get(j-1);  
                globalNextOperator.set((j-1),globalNextOperator.get(j));  
                globalNextOperator.set(j,tempNext);  
            }  
        
        }
    return globalNextOperator;
}


protected ArrayList<String> filteringNextOperators(ArrayList<String> formula){
    ArrayList<String> newformulas= new ArrayList<String>();
    HashMap<Integer, ArrayList<NextPosition>> transformedNext = new HashMap<Integer, ArrayList<NextPosition>>();
    HashMap<Integer, Boolean> hasNext = new HashMap<Integer, Boolean>();
    TimeAbstraction abstractTime = new TimeAbstraction();
    for(int i=0; i < formula.size(); i++)
    {   
        ArrayList<NextPosition> nextArray= abstractTime.countingNextOperator(formula.get(i),i);
        if (nextArray.size()>=1){
            hasNext.put(i, true);
            transformedNext.put(i,nextArray);
        }
        else
            hasNext.put(i, false);
    }
    int globalGCD=1;
    boolean abstraction =false;
    
    if (jRadioButtonAbstraction.isSelected()){
        abstraction = true;
        ArrayList<NextPosition> globalNextOperator = sortingLength(transformedNext,hasNext);
        try{
            allowedBound = Integer.parseInt(jTextFieldErrorBound.getText());
        }catch (NumberFormatException n) {
               System.out.println("Illegle Error Bound!");  
        }
        
        globalGCD = abstractTime.abstractNext(globalNextOperator, allowedBound);
        jLabelAbstraction.setText("Next operators are abstraction by factor "+ globalGCD);
    }
    if (jRadioButtonReduction.isSelected()){
        globalGCD = abstractTime.countingReduction(transformedNext,hasNext);    
    }  
    
    
    if (globalGCD > 1 || abstraction){
        for (int i=0; i<formula.size(); i++){
            if (hasNext.get(i))
               newformulas.add(replacingNextOperators(formula.get(i),transformedNext.get(i),globalGCD));
            else 
               newformulas.add(formula.get(i));
        }
        return newformulas;
     }
    
    return formula;
}

private void jButtonConvertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonConvertActionPerformed
// TODO add your handling code here:
       String fixedPath = "src/specc/translator/tt.py";       
       java.io.File f = new java.io.File(fixedPath);
       if (!f.exists()){
           fixedPath = System.getProperty("user.dir") + "/tt.py";
       }
       
       /*Test weather the user has loaded a file*/
       //if (hasLoadFile == false)
       //{
           String tempInput = jTextAreaSpec.getText();
           if (tempInput.trim().isEmpty()){
               JOptionPane.showMessageDialog(null, "Pease load the specification file!", "Warning", JOptionPane.ERROR_MESSAGE);
               return;
           }
           else{
               //create a temporal file for the input
               BufferedWriter writer = null;
                try {
                    writer = new BufferedWriter(new FileWriter("temp.txt"));
                    String[] spec = tempInput.split("[\\n]");
                    for (String s : spec) {
                        writer.write(s.replace("-", "_"));
                        writer.newLine();
                    }                    
                } catch (IOException e) {
                } finally {
                    try {
                        if (writer != null) {
                            writer.close();
                        }
                    } catch (IOException e) {
                        }
               }
                
               selectedFile = new java.io.File(System.getProperty("user.dir") + "/temp.txt");
               if (hasLoadFile == false)
                outputFile = "temp_ltl.txt";
           }
       //}
       String[] comm = {"python",fixedPath,"-I",selectedFile.getAbsolutePath()};
       StringBuilder ltlSpec = new StringBuilder("");
       StringBuilder inputSpec = new StringBuilder("");
       StringBuilder outputSpec = new StringBuilder("");
       ArrayList<String> ltlFormulas = new ArrayList<String>();
       ArrayList<String> inputList = new ArrayList<String>();
       ArrayList<String> outputList = new ArrayList<String>();
       ArrayList<String> newInputVarList = new ArrayList<String>();
       ArrayList<String> newOutputVarList = new ArrayList<String>();
       try{        
            Process p = Runtime.getRuntime().exec(comm);
            p.waitFor();
            
            String s;
            BufferedReader stdInput = new BufferedReader(new InputStreamReader(p.getInputStream()));
            BufferedReader stdError = new BufferedReader(new InputStreamReader(p.getErrorStream()));

            System.out.println("Here is the standard error of the command (if any):\n");
            while ((s = stdError.readLine()) != null) {
                System.out.println(s);
            }
                
            
            while ((s = stdInput.readLine()) != null) {
               if (!s.trim().equalsIgnoreCase("")) {
                     if (s.trim().startsWith(INPUT)) {
                        if (inputSpec.toString().equals("")) {
                           inputSpec.append(s.trim().substring(INPUT.length()+1));
                        } else {
                           inputSpec.append(" , ").append(s.trim().substring(INPUT.length()+1));
                        }
                      } else if (s.trim().startsWith(OUTPUT)) {
                        if (outputSpec.toString().equals("")) {
                           outputSpec.append(s.trim().substring(OUTPUT.length()+1));
                        } else {
                           outputSpec.append(" , ").append(s.trim().substring(OUTPUT.length()+1));
                        }
               } else {
                       ltlFormulas.add(s.trim());
                }
               }
            }
            p.destroy();
       }catch(Exception e2) {System.out.println(e2);}
         
       ArrayList<String> newFormulas = filteringNextOperators(ltlFormulas);
       if (newFormulas != null){
            for (int i=0; i< newFormulas.size(); i++)
                 ltlSpec.append(newFormulas.get(i)).append("\n");
       }
       else{
             for (int i=0; i< ltlFormulas.size(); i++)
                ltlSpec.append(ltlFormulas.get(i)).append("\n");
       }
       if (inputSpec.toString().isEmpty() && outputSpec.toString().isEmpty()){
           JOptionPane.showMessageDialog(null, "Input and Output information are both wrong!", "Alert", JOptionPane.ERROR_MESSAGE);
           return;
       }
       else{            
            spec.put(INPUT, inputSpec.toString().trim());
            spec.put(OUTPUT, outputSpec.toString().trim());
            spec.put(LTL, ltlSpec.toString());

            //deal with output
            jTextAreaLTL.setText(spec.get(LTL));

             String delimiter = ",";
             String[] temp;
             temp = spec.get(INPUT).split(delimiter);
             for(int i=0; i< temp.length; i++)
             if(!temp[i].trim().equals("None"))
             {
                  inputList.add(temp[i].trim());
             }
             temp = spec.get(OUTPUT).split(delimiter);
             for(int i=0; i< temp.length; i++)
                 if(!temp[i].trim().equals("None"))
                 {
                      outputList.add(temp[i].trim()); 
                 }
                 //extract variable from the inputfomula and outputformula.
                 clarifySignals(inputList,outputList,newInputVarList,newOutputVarList);
                 inputSignals.clear();
                 outputSignals.clear();
                 for(int i=0;i< newInputVarList.size();i++)
                 {
                   inputSignals.add((newInputVarList.get(i).trim()));
                 }
                 for(int i=0;i< newOutputVarList.size();i++)
                 {
                   outputSignals.add((newOutputVarList.get(i)).trim());
                 }
                 redrawLists();
                 writetoFile();
       }
}//GEN-LAST:event_jButtonConvertActionPerformed

// to distinguish inputs from output
private void clarifySignals(ArrayList<String> inputList, ArrayList<String> outputList,ArrayList<String> newInputVarList,ArrayList<String> newOutputVarList){
    //todo
    //
    //assign unique signals to inputSignals and outputSignals
    
    ArrayList<String> inputVarList = new ArrayList<String>();
    ArrayList<String> inputOperList = new ArrayList<String>();
    ArrayList<String> newInputOperList = new ArrayList<String>();
    ArrayList<String> outputVarList = new ArrayList<String>();
    ArrayList<String> outputOperList = new ArrayList<String>();
    //ArrayList<String> newOutputVarList = new ArrayList<String>();
    ArrayList<String> newOutputOperList = new ArrayList<String>();
    getVarandOper(inputList,inputVarList,inputOperList);
    getVarandOper(outputList,outputVarList,outputOperList);
    //delete the variabels such as None, which are mistaken as variabels .
    for(int i=0;i<inputVarList.size();i++)
    {
        if(inputVarList.get(i).contains("None") && inputVarList.get(i).contains("X"))
        {
            inputVarList.remove(i);
            inputOperList.remove(i);
            i = i-1;
        }
    }
    for(int i=0;i<outputVarList.size();i++)
    {
        if(outputVarList.get(i).contains("None") && outputVarList.get(i).contains("X"))
        {
            outputVarList.remove(i);
            outputOperList.remove(i);
            i = i-1;
        }
    }
    removeArrayDuplicate(inputVarList,inputOperList,newInputVarList,newInputOperList);
    removeArrayDuplicate(outputVarList,outputOperList,newOutputVarList,newOutputOperList);
    for(int i=0;i<newInputVarList.size();i++)
    {
        if(newOutputVarList.contains(newInputVarList.get(i)))
        {
            int location = newOutputVarList.indexOf(newInputVarList.get(i));
            if(newOutputOperList.get(location).equals("!"))
            {
              newInputVarList.remove(i);
              newInputOperList.remove(i);
              i = i-1;  
            }
            else if(newOutputOperList.get(location).equals("!!")&&newInputOperList.get(i).equals("!!"))
            {
              newInputVarList.remove(i);
              newInputOperList.remove(i);
              i = i-1;    
            }
            else if(newOutputOperList.get(location).equals("!!")&&newInputOperList.get(i).equals("!"))
            {
                newOutputVarList.remove(location);
                newOutputOperList.remove(location);
            }
             
            
        }
    }
    //To handle this situation that newInputVarList is empty.
    if(newInputVarList.isEmpty())
    {
        System.out.println("The input is empty");
        if (!newOutputVarList.isEmpty()){
            newInputVarList.add(newOutputVarList.get(0));
            newInputOperList.add(newOutputOperList.get(0));
            newOutputVarList.remove(0);
            newOutputOperList.remove(0);
        }
        else 
            System.out.println("The output is empty");
    }
    //To handle this situation that newOutputVarList is empty.
    if(newOutputVarList.isEmpty())
    {
        newOutputVarList.add(newInputVarList.get(0));
        newOutputOperList.add(newInputOperList.get(0));
        newInputVarList.remove(0);
        newInputOperList.remove(0);
    }
   
}
private void getVarandOper(ArrayList<String> List,ArrayList<String> varList,ArrayList<String> operList){
    ArrayList<String> tempVarList = new ArrayList<String>();
    for(int i=0;i<List.size();i++)
    {
        String str = List.get(i);
        int flag = 0;
        String temp = new String();
        for(int j=0;j<str.length();j++)
        {
            if((('a'<= str.charAt(j)&&str.charAt(j)<='z')||('A'<= str.charAt(j)&&str.charAt(j)<='Z')||('0'<= str.charAt(j)&&str.charAt(j)<='9')||str.charAt(j) == '_'||str.charAt(j) == '!')&&flag==0)
            {
                temp = temp+str.charAt(j);
                flag = 1;
            }
            else if((('a'<= str.charAt(j)&&str.charAt(j)<='z')||('A'<= str.charAt(j)&&str.charAt(j)<='Z')||('0'<= str.charAt(j)&&str.charAt(j)<='9')||str.charAt(j) == '_'||str.charAt(j) == '!')&&flag==1)
            {
                temp = temp+str.charAt(j);
            }
            else if(!(('a'<= str.charAt(j)&&str.charAt(j)<='z')||('A'<= str.charAt(j)&&str.charAt(j)<='Z')||('0'<= str.charAt(j)&&str.charAt(j)<='9')||str.charAt(j) == '_'||str.charAt(j) == '!')&&flag==1)
            {
                tempVarList.add(temp);
                temp = "";
                flag = 0;
                
            }
            else 
            {
                
            }
            
        }
        
    }
    for(int i=0;i<tempVarList.size();i++)
    {
        String tempstr = "";
        tempstr=tempVarList.get(i);
        if(tempstr.contains("!"))
        {
           varList.add(tempstr.replace("!", ""));
           operList.add("!");
        }
        else
        {
           varList.add(tempstr);
           operList.add("!!");
        }
    }
    

}
private void removeArrayDuplicate(ArrayList<String> varList,ArrayList<String> operList,ArrayList<String> newVarList,ArrayList<String> newOperList)
{
   for(int i=0;i<varList.size();i++)
    {
        if(newVarList.contains(varList.get(i)))
        {
            int location = newVarList.indexOf(varList.get(i));
            if(newOperList.get(location).equals("!!"))
            {
                newOperList.set(location, operList.get(i));
                       
            }
        }
        else
        {
            newVarList.add(varList.get(i));
            newOperList.add(operList.get(i));
        }
    } 
}
private void redrawLists(){

            if (inputSignals.size() > 0){
                DefaultListModel dlminput = new DefaultListModel();
                for(int i=0; i < inputSignals.size(); i ++){
                    dlminput.addElement(inputSignals.get(i).toString());
                }
                
                jListInput.setModel(dlminput);
                //jList1.setSelectedIndex(0);
            }
            if (outputSignals.size() > 0){
                DefaultListModel dlmoutput = new DefaultListModel();
                for(int i=0; i < outputSignals.size(); i ++){
                    dlmoutput.addElement(outputSignals.get(i).toString());
                }
                jListOutput.setModel(dlmoutput);
                //jList2.setSelectedIndex(0);
            }
}
private void jListOutputMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListOutputMouseClicked
// TODO add your handling code here:
    outputAdjust = jListOutput.getSelectedIndex();
}//GEN-LAST:event_jListOutputMouseClicked

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
// TODO add your handling code here:
   
    if (inputAdjust >= 0){
        
        outputSignals.add(inputSignals.get(inputAdjust));
        inputSignals.remove(inputAdjust);
        
        redrawLists();
        inputAdjust =-1;
    }
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
// TODO add your handling code here:
    if (outputAdjust >= 0){
        inputSignals.add(outputSignals.get(outputAdjust));
        outputSignals.remove(outputAdjust);
        redrawLists();
        outputAdjust = -1;
    }
}//GEN-LAST:event_jButton5ActionPerformed

protected void writetoFile(){
    BufferedWriter writer = null;
    try {
        //write the generated LTL formulas to a file.
        writer = new BufferedWriter(new FileWriter(outputFile));
        String[] spec = jTextAreaLTL.getText().split("[\\n]");
        for (String s : spec) {
            writer.write(s);
            writer.newLine();
        }
        writer.newLine();
        String temp = new String();
        temp = getInputString();
        writer.write("INPUT " + temp);
        writer.newLine();
        temp = getOutputString();
        writer.write("OUTPUT " + temp);
        writer.newLine();
        } catch (IOException e) {
        } finally {
            try {
                if (writer != null) {
                    writer.close();
                }
            } catch (IOException e) {
            }
        }
}

private String getInputString(){
    String input = new String();
    for (int i=0; i< inputSignals.size(); i++){
            if (i==inputSignals.size()-1)
                input = input + (inputSignals.get(i)).trim();
            else
                input = input + (inputSignals.get(i)).trim() + ",";
        }
    return input;        
}

private String getOutputString(){
    String output = new String();
    for (int i=0; i< outputSignals.size(); i++){
            if (i==outputSignals.size()-1)
                output = output + (outputSignals.get(i)).trim();
            else
                output = output + (outputSignals.get(i)).trim() + ",";
        }
    return output;        
}

private void callNewSynthesisLibrary(){
        SolverUtility solver = new SolverUtility();
        
        Object[] optionsTechnique = {"CoBuechi", "Buechi"};

        int optionTechnique = JOptionPane.showOptionDialog(this, "Specify synthesis techniques", "G4LTL",
                JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE,
                null, optionsTechnique, optionsTechnique[0]);
        
        String input = getInputString();
        String output = getOutputString();
        
        CompositionalProblemDescription prob = new CompositionalProblemDescription(SolverUtility.getSignals(input),
                solver.getSignals(output),
                solver.parseLTLspecification(solver.changeSpecToInternalFormat(jTextAreaLTL.getText())),
                Integer.parseInt(jTextFieldUnroll.getText()),
                solver.parseCompositionalLTLspecification(solver.changeSpecToInternalFormat(jTextAreaLTL.getText())));
        
        long t1=System.currentTimeMillis();
        // Check if optimization can be applied.
        ArrayList<String> specltl = new ArrayList<String>();
        String[] ss = jTextAreaLTL.getText().split("\\n");
        for (String s : ss) {
            if (!s.trim().equals("")) {
                specltl.add(s);
            }
        }
        jTextAreaResult.setText("");

        CompressibilityCheck check = new CompressibilityCheck();
        check.checkCompressibility(specltl, prob);

        if (check.isCompressible()) {
            // Ask if the user wants to perform automatic compression.
            // ImageIcon icon = new ImageIcon("src/g4ltl/G4LTL.png");

            int dialogResult = JOptionPane.showConfirmDialog(null,
                    "Specification rewriting possible.\n"
                    + "Use it to reduce the synthesis time?", "G4LTL",
                    JOptionPane.YES_NO_CANCEL_OPTION,
                    JOptionPane.QUESTION_MESSAGE, null);

            if (dialogResult == JOptionPane.YES_OPTION) {
                // Set new output variables
                prob.getOutputVariables().removeAll(check.getRewrittenOutputVariables());
                prob.getOutputVariables().addAll(check.getNewOutputVariables());

                // Set new specification
                prob.setLtlSpecification(solver.parseLTLspecification(
                        solver.changeSpecToInternalFormat(check.getRewrittenSpecification())));
                // Partition into subspecifications (for compositional synthesis)
                prob.setPartialSpecification(solver.parseCompositionalLTLspecification(
                        solver.changeSpecToInternalFormat(check.getRewrittenSpecification())));

                // Print the translation scheme
                jTextAreaResult.append("----- Rewritten specification -----\n");
                jTextAreaResult.append(check.getRewrittenSpecification() + "\n");
                jTextAreaResult.append("----- New output variables -----\n");
                jTextAreaResult.append(check.getNewOutputVariables() + "\n\n");
                jTextAreaResult.append("----- Relation between existing variables & new output variables -----\n");

                for (String var : check.getRewrittenOutputVariables()) {
                    jTextAreaResult.append("Rewrite " + var + " by : " + CompressibilityCheck.reEncodeValuation(var, check.getPositiveVariableRewriteMap(), check.getNewOutputVariables()) + "\n");
                    jTextAreaResult.append("Rewrite !" + var + " by : " + CompressibilityCheck.reEncodeValuation("!" + var, check.getNegativeVariableRewriteMap(), check.getNewOutputVariables()) + "\n");
                }
                jTextAreaResult.append("\n----- Result of synthesis -----\n");

            } else if (dialogResult == JOptionPane.CANCEL_OPTION) {
                return ;
            }
        }

        // Invoke the engine, and redirect the synthesized result to the result panel.
        SynthesisEngine engine = new SynthesisEngine();
        boolean ltl2buchi = true;
        boolean findStrategy = true;
        int outputOption = SynthesisEngine.OUTPUT_PSUEDO_CODE;
        if (jRadioButtonSAL.isSelected()) {
            outputOption = SynthesisEngine.OUTPUT_SAL;
        } /*else if (jRadioButtonFSM.isSelected()) {
            outputOption = SynthesisEngine.OUTPUT_FSM_ACTOR_PTOLEMY;
        }*/
        if (optionTechnique == 0) {

            //if (jRadioButtonFindStrategy.isSelected()) {
            if (findStrategy){
                // Enforce to use LTL2Buchi when NEXT operator is used.
                Object[] options = {"Compositional [Y/N]",
                    "Compositional",
                    "Monolithic"};
                int dialogCompositional = JOptionPane.showOptionDialog(null,
                        "Perform compositional synthesis?",
                        "G4LTL",
                        JOptionPane.YES_NO_CANCEL_OPTION,
                        JOptionPane.QUESTION_MESSAGE, null,
                        options, options[1]);
                
                if (dialogCompositional == 0 || dialogCompositional == 1) {
                    boolean isShownStrategy = (dialogCompositional == 0) ? false : true;
                    jTextAreaResult.append("\n" + (engine.invokeCompositionalCoBuechiEngine(prob,
                            ltl2buchi, outputOption,
                            findStrategy, isShownStrategy)).getMessage1());
                } else {
                    jTextAreaResult.append("\n" + engine.invokeMonolithicCoBuechiEngine(prob,
                            ltl2buchi, outputOption,
                            findStrategy).getMessage1());
                }
            } else {
                jTextAreaResult.append("\n" + engine.invokeMonolithicCoBuechiEngine(prob,
                        ltl2buchi, outputOption,
                        findStrategy).getMessage1());
            }

        } else {
            jTextAreaResult.append("\n" + engine.invokeMonolithicBuechiEngine(prob,
                    ltl2buchi, outputOption,
                    findStrategy).getMessage1());
        }
        long t2=System.currentTimeMillis()-t1;
        System.out.println("The execution time is " +  String.valueOf(t2/1000) + " seconds.");

}

private void jButtonCheckingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCheckingActionPerformed
// TODO add your handling code here:
    
        writetoFile();
        //call the function for synthesis
        
        SynthesisEngine engine = new SynthesisEngine();
        try{
            //calling the new library
            callNewSynthesisLibrary();
         }
        catch (Exception ex) {
            printErrorToResult(ex);
        }
        
}//GEN-LAST:event_jButtonCheckingActionPerformed

private void printErrorToResult(Exception ex) {
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        ex.printStackTrace(pw);
        jTextAreaLTL.append("\n\n------\n" + sw.toString());
    }

//copy end
//===============================

private void jListInputMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListInputMouseClicked
// TODO add your handling code here:
     inputAdjust = jListInput.getSelectedIndex();
}//GEN-LAST:event_jListInputMouseClicked

private void jRadioButtonPsuedocodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonPsuedocodeActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jRadioButtonPsuedocodeActionPerformed

private void jTextFieldUnrollActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldUnrollActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jTextFieldUnrollActionPerformed

    private void jTextFieldErrorBoundActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldErrorBoundActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldErrorBoundActionPerformed

    private void jRadioButtonAbstractionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonAbstractionActionPerformed
        // TODO add your handling code here:
        //jTextFieldErrorBound.setVisible(true);
        //jLabelError.setVisible(true);
    }//GEN-LAST:event_jRadioButtonAbstractionActionPerformed

    private void jRadioButtonReductionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonReductionActionPerformed
        // TODO add your handling code here:
        //jTextFieldErrorBound.setVisible(false);
        //jLabelError.setVisible(false);
    }//GEN-LAST:event_jRadioButtonReductionActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(SpecC.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(SpecC.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(SpecC.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(SpecC.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new SpecC().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroupAbstraction;
    private javax.swing.ButtonGroup buttonGroupFeature;
    private javax.swing.ButtonGroup buttonGroupFrontEnd;
    private javax.swing.ButtonGroup buttonGroupOutput;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButtonChecking;
    private javax.swing.JButton jButtonConvert;
    private javax.swing.JButton jButtonLoadFile;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabelAbstraction;
    private javax.swing.JLabel jLabelError;
    protected javax.swing.JList jListInput;
    protected javax.swing.JList jListOutput;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JRadioButton jRadioButtonAbstraction;
    private javax.swing.JRadioButton jRadioButtonPsuedocode;
    private javax.swing.JRadioButton jRadioButtonReduction;
    private javax.swing.JRadioButton jRadioButtonSAL;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JTextArea jTextAreaLTL;
    private javax.swing.JTextArea jTextAreaResult;
    private javax.swing.JTextArea jTextAreaSpec;
    private javax.swing.JTextField jTextFieldErrorBound;
    private javax.swing.JTextField jTextFieldUnroll;
    // End of variables declaration//GEN-END:variables
}
